OGRE: Ogre::BoneArrayMemoryManager Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Attributes | List of all members
Ogre::BoneArrayMemoryManager Class Reference
Core » Memory

Implementation to create the Transform variables needed by Bones. More...

`#include <OgreBoneArrayMemoryManager.h>`

Inheritance diagram for Ogre::BoneArrayMemoryManager:
[legend]

## Public Types
enum | MemoryTypes { Owner = 0, Position, Orientation, Scale, ParentMat, ParentNode, WorldMat, FinalMat, InheritOrientation, InheritScale, NumMemoryTypes }
typedef std::vector< ptrdiff_t > | PtrdiffVec

## Public Member Functions
| BoneArrayMemoryManager (uint16 depthLevel, size_t hintMaxNodes, size_t cleanupThreshold=100, size_t maxHardLimit=MAX_MEMORY_SLOTS, RebaseListener *rebaseListener=0)
| Constructor. More...
void | createNewNode (BoneTransform &outTransform)
| Requests memory for a new Bone (for the Array vectors & matrices) May be also be used for a new Entity, etc. More...
void | defragment (void)
| Triggers on demand a defragmentation of the pools, so that all slots become contiguous in memory. More...
void | destroy ()
| Destroys the memory ptrs. More...
void | destroyNode (BoneTransform &inOutTransform)
| Releases memory acquired through. More...
size_t | getAllMemory () const
| Gets all memory reserved for this manager. More...
size_t | getFirstNode (BoneTransform &outTransform)
| Retrieves a BoneTransform pointing to the first Bone. More...
size_t | getFreeMemory () const
| Gets available memory in bytes. More...
size_t | getNumUsedSlotsIncludingFragmented () const
| Returns mUsedMemory. More...
size_t | getUsedMemory () const
| Gets used memory in bytes (not including waste) More...
size_t | getWastedMemory () const
| Gets wasted memory (perform a cleanup to fix) More...
void | initialize ()
| Initializes mMemoryPools. More...
void | shrinkToFit (void)
| Defragments memory, then reallocates a smaller pool that tightly fits the current number of objects. More...

## Static Public Attributes
static const CleanupRoutines | BoneCleanupRoutines [NumMemoryTypes]
static const CleanupRoutines | BoneInitRoutines [NumMemoryTypes]
static const size_t | ElementsMemSize [NumMemoryTypes]
static const size_t | MAX_MEMORY_SLOTS

## Detailed Description

Implementation to create the Transform variables needed by Bones.

Author
  Matias N. Goldberg

Version
  1.0

## Member Typedef Documentation

## ◆ PtrdiffVec

typedef std::vector<ptrdiff_t> Ogre::ArrayMemoryManager::PtrdiffVec
| inherited

## Member Enumeration Documentation

## ◆ MemoryTypes

enum Ogre::BoneArrayMemoryManager::MemoryTypes

Enumerator
Owner |
Position |
Orientation |
Scale |
ParentMat |
ParentNode |
WorldMat |
FinalMat |
InheritOrientation |
InheritScale |
NumMemoryTypes |

## Constructor & Destructor Documentation

## ◆ BoneArrayMemoryManager()

Ogre::BoneArrayMemoryManager::BoneArrayMemoryManager | ( | uint16 | depthLevel,
|  | size_t | hintMaxNodes,
|  | size_t | cleanupThreshold = `100`,
|  | size_t | maxHardLimit = `MAX_MEMORY_SLOTS`,
|  | RebaseListener * | rebaseListener = `0`
| ) |  |

Constructor.

@See intialize. @See destroy.

Parameters

  elementsMemSize | Array containing the size in bytes of each element type (i.e. NodeElementsMemSize)
  initRoutines | Array containing the cleanup function that will be called when default initializing memory. Unlike cleanupRoutines, just leave the function pointer null if all you want is just to initialize to 0.
  cleanupRoutines | Array containing the cleanup function that will be called when performing cleanups. Many pointers can use the flatCleaner and is the fastest. However Array variables (i.e. ArrayVector3) have a layout where flatCleaner won't work correctly because the data is interleaved (rather than flat).
  numElementsSize | Number of entries in elementsMemSize
  depthLevel | Value only used to pass to the listener. Identifies to which hierarchy depth level this memory manager belongs to.
  hintMaxNodes | Hint on how many SceneNodes we'll be creating.
  cleanupThreshold | The threshold at which a cleanup is triggered after too many nodes have been destroyed in a non-LIFO order or without being created again. -1 to disable cleanups.
  maxHardLimit | Maximum amount of SceneNodes. The manager is not allowed to grow and consume more memory past that limit. MAX_MEMORY_SLOTS for no limit. This is useful when target architecture has much less memory than the dev machine.

  Note that if hintMaxNodes < maxHardLimit, the manager may be forced to do temporary allocations (to do the reallocs) thus during a brief perdiod of time it may consume more memory than the established hard limit (up to 2x).

Parameters

  rebaseListener | The listener to be called when cleaning up or growing the memory pool. If null, cleanupThreshold is set to -1 & maxHardLimit will be set to hintMaxNodes

## Member Function Documentation

## ◆ createNewNode()

void Ogre::BoneArrayMemoryManager::createNewNode | ( | BoneTransform & | outTransform | ) |

Requests memory for a new Bone (for the Array vectors & matrices) May be also be used for a new Entity, etc.

Parameters

  outTransform | Out: The transform with filled memory pointers

## ◆ defragment()

void Ogre::ArrayMemoryManager::defragment | ( | void |  | ) |
| inherited

Triggers on demand a defragmentation of the pools, so that all slots become contiguous in memory.

ArrayMemoryManager::destroySlot already does this when the number of fragmented slots reaches mCleanupThreshold

## ◆ destroy()

void Ogre::ArrayMemoryManager::destroy | ( |  | ) |
| inherited

Destroys the memory ptrs.

@See initialize

Remarks
  If there were slots in use, make sure they're no longer used, as their ptrs will become dangling ptrs. We don't assert because this may be valid behavior (i.e. on shutdown)

## ◆ destroyNode()

void Ogre::BoneArrayMemoryManager::destroyNode | ( | BoneTransform & | inOutTransform | ) |

Releases memory acquired through.

See also
  createNewNode

Remarks
  For optimal results, try to respect LIFO order in the removals

Parameters

  inOutTransform | Out: Transform to destroy. Pointers are nullified

## ◆ getAllMemory()

size_t Ogre::ArrayMemoryManager::getAllMemory | ( |  | ) | const
| inherited

Gets all memory reserved for this manager.

## ◆ getFirstNode()

size_t Ogre::BoneArrayMemoryManager::getFirstNode | ( | BoneTransform & | outTransform | ) |

Retrieves a BoneTransform pointing to the first Bone.

Remarks
  @See BoneMemoryManager::getStart

Parameters

  outTransform | [out] Transform with filled pointers to the first Node in this depth

Returns
  Number of Nodes in this depth level

## ◆ getFreeMemory()

size_t Ogre::ArrayMemoryManager::getFreeMemory | ( |  | ) | const
| inherited

Gets available memory in bytes.

## ◆ getNumUsedSlotsIncludingFragmented()

size_t Ogre::ArrayMemoryManager::getNumUsedSlotsIncludingFragmented | ( |  | ) | const
| inherited

Returns mUsedMemory.

When ARRAY_PACKED_REALS = 4, and 4 objects have been created but the 2nd one has been deleted, getNumUsedSlotsIncludingFragmented will still return 4 until the 4th object is removed or a cleanup is performed

## ◆ getUsedMemory()

size_t Ogre::ArrayMemoryManager::getUsedMemory | ( |  | ) | const
| inherited

Gets used memory in bytes (not including waste)

## ◆ getWastedMemory()

size_t Ogre::ArrayMemoryManager::getWastedMemory | ( |  | ) | const
| inherited

Gets wasted memory (perform a cleanup to fix)

## ◆ initialize()

void Ogre::ArrayMemoryManager::initialize | ( |  | ) |
| inherited

Initializes mMemoryPools.

Once it has been called, destroy() must be called. @See destroy

Remarks
  The destructor won't free the data, if you don't call destroy, memory will leak. Calling initialize twice is possible and won't leak, but will free the previous memory ptrs without calling the registered RebaseListener. So if there were slots in use, their pointers will become dangling. An assert will trigger if this happens.

## ◆ shrinkToFit()

void Ogre::ArrayMemoryManager::shrinkToFit | ( | void |  | ) |
| inherited

Defragments memory, then reallocates a smaller pool that tightly fits the current number of objects.

Useful when you know you won't be creating more slots and you need to reclaim memory.

## Member Data Documentation

## ◆ BoneCleanupRoutines

const CleanupRoutines Ogre::BoneArrayMemoryManager::BoneCleanupRoutines[NumMemoryTypes]
| static

## ◆ BoneInitRoutines

const CleanupRoutines Ogre::BoneArrayMemoryManager::BoneInitRoutines[NumMemoryTypes]
| static

## ◆ ElementsMemSize

const size_t Ogre::BoneArrayMemoryManager::ElementsMemSize[NumMemoryTypes]
| static

## ◆ MAX_MEMORY_SLOTS

const size_t Ogre::ArrayMemoryManager::MAX_MEMORY_SLOTS
| staticinherited

The documentation for this class was generated from the following file:

- OgreBoneArrayMemoryManager.h